/* PHYVMS.C b1.2    Physical I/O module for VMS */

/*  How come VMS is so much easier to do physical I/O on than
    those other ^%$@*! systems?   */


#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <iodef.h>
#include <descrip.h>
#ifndef __GNUC__
#include <starlet.h>
#endif
#include "phy.h"

#define chk(sts)  {register chksts; if (((chksts = sts) & 1) == 0) lib$stop(chksts);}

unsigned phyio_init(int devlen,char *devnam,unsigned *handle)
{
    struct dsc$descriptor devdsc;
    devdsc.dsc$w_length = devlen;
    devdsc.dsc$a_pointer = devnam;
    *handle = 0;
    return sys$assign(&devdsc,handle,0,0,0,0);
}

unsigned phyio_close(unsigned handle)
{
    return sys$dassgn(handle);
}

unsigned phyio_read(unsigned handle,unsigned block,unsigned length,char *buffer)
{
#ifdef DEBUG
    printf("Phyio block: %d (%d bytes)\n",block,length);
#endif
    return sys$qiow(1,handle,IO$_READLBLK,NULL,0,0,buffer,length,block,0,0,0);
}
